<?php
#-------------------------------------------------------------------------
# Module: Newsletter Made Simple
#        (c) to 2008 by Paul Lempkepf
#        (c) 2008 and on by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to provide a flexible
#  mailing list solution.
#
#-------------------------------------------------------------------------
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if( !isset($gCms) ) exit;
if( !$this->CheckPermission('Modify Site Preferences') && !$this->Checkpermission('Manage NMS Preferences') ) return;

$this->SetCurrentTab('fielddefs');

if( isset($params['cancel']) ) {
  $this->SetMessage($this->Lang('op_cancelled'));
  $this->RedirectToTab();
}

try {
  function __clean_params($input)
  {
    foreach( $input as $key => $value ) {
      if( !in_array($key,array('id','type','name','prompt','order','optiontext','required')) ) unset($input[$key]);
    }
    return $input;
  }

  $op = trim(get_parameter_value($params,'op','add'));
  $fld = (int)get_parameter_value($params,'fld',-1);
  $form_parms = array('op'=>$op,'fld'=>$fld);
  $obj = null;

  switch( $op ) {
  case 'add':
    if( $fld > 0 ) throw new CmsException($this->Lang('error_invalidparam','fld'));

    try {
      $obj = new nms_fielddef;
      if( isset($params['submit']) ) {
	$obj->load_from_data(__clean_params($params));
	$obj->save();
	$this->SetMessage($this->Lang('msg_fieldadded'));
	$this->RedirectToTab();
      }
    }
    catch( Exception $e ) {
      echo $this->ShowErrors($e->GetMessage());
    }
    break;

  case 'edit':
    if( $fld < 1 ) throw new CmsException($this->Lang('error_invalidparam','fld'));

    try {
      $obj = nms_fielddef::load($fld);
      if( isset($params['submit']) ) {
	$obj->load_from_data(__clean_params($params));
	$obj->save();
	$this->SetMessage($this->Lang('msg_fieldupdated'));
	$this->RedirectToTab();
      }
    }
    catch( Exception $e ) {
      echo $this->ShowErrors($e->GetMessage());
    }
    break;

  case 'del':
    if( $fld < 1 ) throw new CmsException($this->Lang('error_invalidparam','fld'));
    $obj = nms_fielddef::load($fld);
    $obj->delete();
    $this->SetMessage($this->Lang('fielddef_deleted'));
    $this->RedirectToTab();
    break;

  default:
    throw new CmsException($this->Lang('error_invalidparam','op'));
  }


  $tmp = array($obj::TYPE_TEXTBOX=>$this->Lang('fld_textbox'),
	       $obj::TYPE_TEXTAREA=>$this->Lang('fld_textarea'),
	       $obj::TYPE_CHECKBOX=>$this->Lang('fld_checkbox'),
	       $obj::TYPE_DROPDOWN=>$this->Lang('fld_dropdown'));
  $smarty->assign('fieldtypelist',$tmp);
  $smarty->assign('field',$obj);
  $smarty->assign('formstart',$this->CGCreateFormStart($id,'admin_edit_fielddef',$returnid,$form_parms));
  $smarty->assign('formend',$this->CreateFormEnd());
  echo $this->ProcessTemplate('admin_edit_fielddef.tpl');
}
catch( Exception $e ) {
  $this->SetError($e->GetMessage());
  $this->RedirectToTab();
}

#
# EOF
#
?>